export interface Cache {
    _keys?: any[];
    _values?: any[];
    has: (value: any) => boolean;
    set: (key: any, value: any) => void;
    get: (key: any) => any;
}
declare function createCacheModern(): Cache;
/**
 * Get a new cache object to prevent circular references.
 */
export declare const createCache: typeof createCacheModern;
/**
 * Get an empty version of the object with the same prototype it has.
 */
export declare function getCleanClone(prototype: any): any;
declare function getRegExpFlagsModern(regExp: RegExp): string;
/**
 * Get the flags to apply to the copied regexp.
 */
export declare const getRegExpFlags: typeof getRegExpFlagsModern;
export declare function identity<Value>(value: Value): Value;
export {};
